/*
* Sprite3D.js
* https://github.com/boblemarin/Sprite3D.js
* http://minimal.be/lab/Sprite3D
*
* Copyright (c) 2010 boblemarin http://www.minimal.be
* 
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use,
* copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following
* conditions:
* 
* The above copyright notice and this permission notice shall be
* included in all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
* HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
* OTHER DEALINGS IN THE SOFTWARE.
*/

function Sprite3D(element){if(!Sprite3D.prototype._isInit)Sprite3D.isSupported();var p="",s="",rx="",ry="",rz="",ts="",i,alpha=1;this.listeners={};if(element==null){element=document.createElement("div");}
element.style[this._browserPrefix+"TransformStyle"]="preserve-3d";element.style.margin="0px";element.style.padding="0px";element.style.position="absolute";element.style[this._transformProperty]="translateZ(0px)";this.domElement=element;this.style=element.style;this.children=[];}
Sprite3D.prototype.x=0;Sprite3D.prototype.y=0;Sprite3D.prototype.z=0;Sprite3D.prototype.rotationX=0;Sprite3D.prototype.rotationY=0;Sprite3D.prototype.rotationZ=0;Sprite3D.prototype.scaleX=1;Sprite3D.prototype.scaleY=1;Sprite3D.prototype.scaleZ=1;Sprite3D.prototype.width=0;Sprite3D.prototype.height=0;Sprite3D.prototype.regX=0;Sprite3D.prototype.regY=0;Sprite3D.prototype.regZ=0;Sprite3D.prototype.tileWidth=0;Sprite3D.prototype.tileHeight=0;Sprite3D.prototype.domElement=null;Sprite3D.prototype.style=null;Sprite3D.prototype.children=[];Sprite3D.prototype.numChildren=0;Sprite3D.prototype.rotateFirst=false;Sprite3D.prototype.transformString="_p _rx _ry _rz _s";Sprite3D.prototype.setTransformString=function(ts){this.transformString=ts;return this;};Sprite3D.prototype.setX=function(px){this.x=px;return this;};Sprite3D.prototype.setY=function(py){this.y=py;return this;};Sprite3D.prototype.setZ=function(pz){this.z=pz;return this;};Sprite3D.prototype.setPosition=function(px,py,pz){this.x=px;this.y=py;this.z=pz;return this;};Sprite3D.prototype.moveX=function(px){this.x+=px;return this;};Sprite3D.prototype.moveY=function(py){this.y+=py;return this;};Sprite3D.prototype.moveZ=function(pz){this.z+=pz;return this;};Sprite3D.prototype.move=function(px,py,pz){this.x+=px;this.y+=py;this.z+=pz;return this;};Sprite3D.prototype.setRotationX=function(rx){this.rotationX=rx;return this;};Sprite3D.prototype.setRotationY=function(ry){this.rotationY=ry;return this;};Sprite3D.prototype.setRotationZ=function(rz){this.rotationZ=rz;return this;};Sprite3D.prototype.setRotation=function(rx,ry,rz){this.rotationX=rx;this.rotationY=ry;this.rotationZ=rz;return this;};Sprite3D.prototype.rotateX=function(rx){this.rotationX+=rx;return this;};Sprite3D.prototype.rotateY=function(ry){this.rotationY+=ry;return this;};Sprite3D.prototype.rotateZ=function(rz){this.rotationZ+=rz;return this;};Sprite3D.prototype.rotate=function(rx,ry,rz){this.rotationX+=rx;this.rotationY+=ry;this.rotationZ+=rz;return this;};Sprite3D.prototype.setScaleX=function(sx){this.scaleX=sx;return this;};Sprite3D.prototype.setScaleY=function(sy){this.scaleY=sy;return this;};Sprite3D.prototype.setScaleZ=function(sz){this.scaleZ=sz;return this;};Sprite3D.prototype.setScale=function(sx,sy,sz){this.scaleX=sx;this.scaleY=sy;this.scaleZ=sz;return this;};Sprite3D.prototype.setRegistrationPoint=function(rx,ry,rz){this.regX=rx;this.regY=ry;this.regZ=rz;return this;};Sprite3D.prototype.setTransformOrigin=function(px,py){this.style[this._browserPrefix+"TransformOrigin"]=px+" "+py;return this;};Sprite3D.prototype.setSize=function(width,height){this.style.width=(this.width=width)+"px";this.style.height=(this.height=height)+"px";return this;};Sprite3D.prototype.setOpacity=function(alpha){this.style.opacity=this.alpha=alpha;return this;};Sprite3D.prototype.getOpacity=function(){return this.alpha;};Sprite3D.prototype.setClassName=function(className){this.domElement.className=className;return this;};Sprite3D.prototype.getClassName=function(){return this.domElement.className;};Sprite3D.prototype.addClassName=function(className){this.domElement.className+=" "+className+" ";return this;};Sprite3D.prototype.removeClassName=function(className){this.domElement.className=this.domElement.className.replace(className,'');return this;};Sprite3D.prototype.setId=function(id){this.domElement.id=id;return this;};Sprite3D.prototype.getId=function(){return this.domElement.id;};Sprite3D.prototype.setCSS=function(name,value){this.domElement.style[name]=value;return this;};Sprite3D.prototype.getCSS=function(name){return this.domElement.style[name];};Sprite3D.prototype.setInnerHTML=function(value){this.domElement.innerHTML=value;return this;};Sprite3D.prototype.setTileSize=function(width,height){this.tileWidth=width;this.tileHeight=height;return this;};Sprite3D.prototype.setTilePosition=function(tilePosX,tilePosY){this.style.backgroundPosition="-"+(tilePosX*this.tileWidth)+"px -"+(tilePosY*this.tileHeight)+"px";return this;};Sprite3D.prototype.setProperty=function(label,value){this[label]=value;return this;};Sprite3D.prototype.setRotateFirst=function(rf){this.rotateFirst=rf;if(rf){this.transformString="_rx _ry _rz _p _s";}else{this.transformString="_p _rz _ry _rx _s";}
return this;};Sprite3D.prototype.update=function(){this.p="translate3d("+(this.x-this.regX)+"px,"+(this.y-this.regY)+"px,"+(this.z-this.regZ)+"px) ";this.rx="rotateX("+this.rotationX+"deg) ";this.ry="rotateY("+this.rotationY+"deg) ";this.rz="rotateZ("+this.rotationZ+"deg) ";this.s="scale3d("+this.scaleX+", "+this.scaleY+", "+this.scaleX+") ";this.ts=this.transformString;this.ts=this.ts.replace("_p",this.p);this.ts=this.ts.replace("_rx",this.rx);this.ts=this.ts.replace("_ry",this.ry);this.ts=this.ts.replace("_rz",this.rz);this.ts=this.ts.replace("_s",this.s);this.style[this._transformProperty]=this.ts;return this;};Sprite3D.prototype.update2D=function(){this.p="translate("+(this.x-this.regX)+"px,"+(this.y-this.regY)+"px) ";this.rz="rotate("+this.rotationZ+"deg) ";this.s="scale("+this.scaleX+", "+this.scaleY+") ";this.ts=this.transformString;this.ts=this.ts.replace("_p",this.p);this.ts=this.ts.replace("_rx","");this.ts=this.ts.replace("_ry","");this.ts=this.ts.replace("_rz",this.rz);this.ts=this.ts.replace("_s",this.s);this.style[this._transformProperty]=this.ts;return this;};Sprite3D.prototype.updateAll=function(){this.update();this.style.opacity=this.alpha;this.style.width=this.width+"px";this.style.height=this.height+"px";return this.update();};Sprite3D.prototype.updateChildren=function(){for(this.i=0;this.i<this.numChildren;this.i++){this.children[this.i].update();}
return this;};Sprite3D.prototype.updateChildrenAll=function(){for(this.i=0;this.i<this.numChildren;this.i++){this.children[this.i].updateAll();}
return this;};Sprite3D.prototype.updateWithChildren=function(recursive){this.update();for(this.i=0;this.i<this.numChildren;this.i++){if(recursive){this.children[this.i].updateWithChildren(recursive);}else{this.children[this.i].update();}}
return this;};Sprite3D.prototype.addChild=function(e){this.numChildren=this.children.push(e);this.domElement.appendChild(e.domElement);return e;};Sprite3D.prototype.removeChild=function(child){var n=this.children.indexOf(child);if(n>-1){return this.removeChildAt(n);}
return null;};Sprite3D.prototype.removeChildAt=function(n){--this.numChildren;this.domElement.removeChild(this.children[n].domElement);return this.children.splice(n,1)[0];};Sprite3D.prototype.findFromDOMElement=function(element){for(this.i=0;this.i<this.numChildren;this.i++){if(element==this.children[this.i].domElement){return this.children[this.i];}}
return null;};Sprite3D.prototype.listeners={};Sprite3D.prototype.addEventListener=function(event,callback){var fname=event+"_"+callback.name;if(this.listeners[fname]==null){var sprite=this;var fn=function(e){callback(e,sprite);}
this.listeners[fname]=fn;this.domElement.addEventListener(event,fn);}
return this;};Sprite3D.prototype.removeEventListener=function(event,callback){var fname=event+"_"+callback.name;if(this.listeners[fname]!=null){this.domElement.removeEventListener(event,this.listeners[fname]);delete this.listeners[fname];}
return this;};Sprite3D.createCenteredContainer=function(){var c=document.createElement('div'),s=c.style;if(!Sprite3D.prototype._isInit)Sprite3D.isSupported();s[Sprite3D.prototype._browserPrefix+"Perspective"]="800"+(Sprite3D.prototype._browserPrefix=="Moz"?"px":"");s[Sprite3D.prototype._browserPrefix+"PerspectiveOrigin"]="0 0";s[Sprite3D.prototype._browserPrefix+"TransformOrigin"]="0 0";s[Sprite3D.prototype._browserPrefix+"Transform"]="translateZ(0px)";s.position="absolute";s.top="50%";s.left="50%";s.margin="0px";s.padding="0px";document.body.appendChild(c);return new Sprite3D(c);};Sprite3D.createTopLeftCenteredContainer=function(){var c=document.createElement('div'),s=c.style;if(!Sprite3D.prototype._isInit)Sprite3D.isSupported();s[Sprite3D.prototype._browserPrefix+"Perspective"]="800"+(Sprite3D.prototype._browserPrefix=="Moz"?"px":"");s[Sprite3D.prototype._browserPrefix+"Transform"]="translateZ(0px)";s.position="relative";document.body.appendChild(c);return new Sprite3D(c);};Sprite3D.prototype._isInit=false;Sprite3D.prototype._transformProperty="webkitTransform";Sprite3D.prototype._browserPrefix="webkit";Sprite3D.isSupported=function(){var d=document.createElement("div"),prefixes=["","webkit","Moz","o","ms"],n=prefixes.length,i;for(i=0;i<n;i++){if((prefixes[i]+"Perspective")in d.style){Sprite3D.prototype._transformProperty=prefixes[i]+"Transform";Sprite3D.prototype._isInit=true;Sprite3D.prototype._browserPrefix=prefixes[i];return true;}}
for(i=0;i<n;i++){if((prefixes[i]+"Transform")in d.style){Sprite3D.prototype._transformProperty=prefixes[i]+"Transform";Sprite3D.prototype._isInit=true;Sprite3D.prototype._browserPrefix=prefixes[i];Sprite3D.prototype.update=Sprite3D.prototype.update2D;return false;}}
return false;};